#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const Package = __importStar(require("./package.json"));
const build_command_1 = require("./src/build-command");
const create_post_command_1 = require("./src/create-post-command");
const init_command_1 = require("./src/init-command");
const program = new commander_1.Command();
program.name('bloggista')
    .description('Bloggista provides you a CLI to create and manage your blog')
    .version(Package.version);
program.command('init')
    .argument('<name>', 'Name of the blog folder (can\'t contain spaces)')
    .description('Creates the blog structure into given folder name')
    .action(init_command_1.initCommand);
program.command('post')
    .argument('<name>', 'Name of the blog post (can\'t contain spaces)')
    .option('-p, --path <filePath>')
    .description('Creates a blog post under a folder if one is given')
    .action((name, { path }) => (0, create_post_command_1.createPostCommand)(name, path));
program.command('build')
    .description('Builds the entire blog structure into the dist folder')
    .action(build_command_1.buildCommand);
program.parse();
